<template>
  <div id="app" v-bind:class="{ 'is-share-shown': sharedLayerAnimationActive }">
    <share-layer></share-layer>
    <main-header></main-header>
    <main-content></main-content>
    <main-footer></main-footer>
  </div>
</template>

<script>
import MainHeader from "@/components/MainHeader.vue";
import MainFooter from "@/components/MainFooter.vue";
import ShareLayer from "@/components/ShareLayer.vue";
import MainContent from "@/components/MainContent.vue";
import { sharedLayerService } from "@/services/SharedLayerService";
import { fileUploadService } from "@/services/FileUploadService";
import { carService } from "@/services/CarService";

export default {
  components: {
    MainHeader,
    MainFooter,
    ShareLayer,
    MainContent
  },
  provide: {
    sharedLayerService,
    carService,
    fileUploadService
  },
  data: function() {
    return {
      sharedLayerAnimationActive: false
    };
  },
  mounted: function() {
    sharedLayerService.$on("startSharedLayerAnimation", () => {
      this.sharedLayerAnimationActive = true;
    });

    sharedLayerService.$on("endSharedLayerAnimation", () => {
      this.sharedLayerAnimationActive = false;
    });
  }
};
</script>

<style lang="scss">
@import "styles/theme.scss";
@import "styles/breakpoints.scss";
@import "styles/portable-layout.scss";
@import "styles/forms.scss";

html {
  -ms-text-size-adjust: 100%;
  -webkit-text-size-adjust: 100%;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-rendering: optimizeLegibility;
  box-sizing: border-box;
  color: $text-dark-color;
  line-height: 1.4;
  font-family: $theme-font-family;
  -ms-touch-action: manipulation;
  touch-action: manipulation;
  -ms-overflow-style: none;
  font-size: 90%;
}

#app {
  transition: background-color 1.4s linear;
}

.is-share-shown {
  background-color: $dark-color;
  overflow: hidden;
}

.is-share-shown .share-layer {
  -webkit-transform: translateY(0);
  transform: translateY(0);
}

.is-share-shown .main-content,
.is-share-shown .main-footer {
  transform: scale(0.9);
  filter: blur(2px);
}

.is-share-shown .main-content::after {
  z-index: 20;
  opacity: 1;
}

*,
:after,
:before {
  box-sizing: inherit;
}

body,
figure {
  margin: 0;
}

article,
aside,
details,
figcaption,
figure,
footer,
header,
hgroup,
main,
menu,
nav,
section,
summary {
  display: block;
}

canvas,
progress,
video {
  display: inline-block;
  vertical-align: baseline;
}

[hidden],
template {
  display: none;
}

a {
  background-color: transparent;
  text-decoration: none;
  color: inherit;
  transition: all 0.2s;
}

a:active,
a:hover {
  outline: 0;
}

h1 {
  font-size: 2em;
  margin: 0;
}

sub,
sup {
  font-size: 75%;
  line-height: 0;
  position: relative;
  vertical-align: baseline;
}

sup {
  top: -0.5em;
}

sub {
  bottom: -0.25em;
}

img {
  border: 0;
}

svg:not(:root) {
  overflow: hidden;
}

button,
input,
select,
textarea {
  color: inherit;
  font: inherit;
  margin: 0;
}

button {
  overflow: visible;
  appearance: none;
  padding: 0;
  border: 0 none;
  background-color: transparent;
}

button,
select {
  text-transform: none;
}

html input[type="button"],
input[type="reset"],
input[type="submit"] {
  -webkit-appearance: button;
  cursor: pointer;
}

button[disabled],
html input[disabled] {
  cursor: default;
}

button::-moz-focus-inner,
input::-moz-focus-inner {
  border: 0;
  padding: 0;
}

input {
  line-height: normal;
}

input[type="checkbox"],
input[type="radio"] {
  box-sizing: border-box;
  padding: 0;
}

input[type="number"]::-webkit-inner-spin-button,
input[type="number"]::-webkit-outer-spin-button {
  height: auto;
}

input[type="search"] {
  -webkit-appearance: textfield;
  box-sizing: content-box;
}

input[type="search"]::-webkit-search-cancel-button,
input[type="search"]::-webkit-search-decoration {
  -webkit-appearance: none;
}

fieldset {
  border: 0;
  margin: 0;
  padding: 0;
}

legend {
  border: 0;
  padding: 0;
}

textarea {
  overflow: auto;
  resize: vertical;
  vertical-align: top;
}

img,
svg {
  vertical-align: middle;
}

img,
object {
  max-width: 100%;
}

object {
  display: block;
  width: 100%;
}

:-moz-ui-invalid {
  box-shadow: none;
}

@keyframes spinner {
  100% {
    transform: rotate(1turn);
  }
}

@keyframes fave-heart {
  0% {
    background-position: 0 0;
  }
  100% {
    background-position: -2800px 0;
  }
}

@keyframes fade {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}

/* === SCROLLBAR === */
::-webkit-scrollbar-track {
  background-color: transparent;
}

::-webkit-scrollbar {
  width: 0;
  background-color: transparent;
}

::-webkit-scrollbar-thumb {
  background-color: transparent;
}

/* === PROJECT === */
::-moz-selection {
  background: $primary-color;
  text-shadow: none;
}

::selection {
  background: $primary-color;
  text-shadow: none;
}

.is-loading {
  position: relative;
}

.is-loading::after,
.is-loading::before {
  position: absolute;
  z-index: 20;
}

.is-loading::before {
  content: "";
  left: 0;
  top: 0;
  right: 0;
  bottom: 0;
  background-color: rgba(0, 0, 0, 0.702);
}

.is-loading::after {
  content: "";
  width: 36px;
  height: 36px;
  left: 50%;
  top: 50%;
  margin: -18px 0 0 -18px;
  border-radius: 50%;
  border-width: 6px;
  border-style: solid;
  border-color: $primary-color transparent;
  animation: spinner 1s linear infinite;
}

img {
  vertical-align: bottom;
}

a:link {
  word-wrap: break-word;
}

a,
button,
label {
  cursor: pointer;
}

button:focus {
  outline: 0 none;
}

svg,
img,
.btn,
.form__el,
.project__actions {
  user-select: none;
}

svg {
  max-width: 100%;
}

.flickity-prev-next-button {
  background: none;
  transition: background-color 0.3s;
}

/* === BUTTON === */
.btn {
  display: inline-block;
  vertical-align: middle;
  min-width: 12em;
  font: 1rem/2.5 BlinkMacSystemFont, "Segoe UI", Roboto, Helvetica, Arial,
    sans-serif;
  padding-left: 0.705em;
  padding-right: 0.705em;
  border-width: 2px;
  border-style: solid;
  text-transform: uppercase;
  text-align: center;
  position: relative;
  overflow: hidden;
  transition: background-color 0.3s cubic-bezier(0.215, 0.61, 0.355, 1);
  transition: transform 0.2s cubic-bezier(0.215, 0.61, 0.355, 1),
    background-color 0.3s cubic-bezier(0.215, 0.61, 0.355, 1);
}

.btn::after {
  content: "";
  position: absolute;
  width: 100%;
  height: 100%;
  left: 0;
  top: 0;
  transform: translateX(-100%);
  transition: transform 0.2s cubic-bezier(0.075, 0.82, 0.165, 1);
}

.btn--sec::after {
  background-color: rgba(0, 0, 0, 0.502);
}

.btn--main {
  color: $text-light-color;
  border-color: $primary-color;
  background-color: $primary-color;

  &[disabled] {
    background-color: $neutral-color;
    border-color: $neutral-color;
  }
}

.btn--main::after {
  background: rgba(255, 255, 255, 0.251);
}

.btn--full {
  display: block;
  width: 100%;
}

.btn--share {
  border: 0 none;
  min-width: 20em;
  color: $text-light-color;
}

.btn--rounded {
  display: inline-block;
  width: 3em;
  height: 3em;
  line-height: 3;
  margin: 0 0.5em;
  border-radius: 100%;
  color: $text-light-color;
  text-align: center;
  position: relative;
  transition: none;
}

.btn--rounded .icon {
  height: 0.75em;
  width: 0.75em;
}

.btn--fb {
  background-color: #3b5997;
}

.btn--tw {
  background-color: #00acee;
}

.btn--pint {
  background-color: #bd081c;
}

.btn:active {
  transform: scale(0.9);
}

.btn-wrapper--center {
  text-align: center;
}

/* === ICON === */
.icon {
  display: inline-block;
  width: 1em;
  height: 1.1em;
  fill: currentColor;
}

.icon--share,
.icon--share path {
  transition-duration: 1s;
  transition-timing-function: cubic-bezier(0.645, 0.045, 0.355, 1);
}

.icon--share {
  fill: #ffffff;
  transition-property: fill;
}

.icon--share path {
  stroke-dasharray: 4553;
  stroke-dashoffset: 4553;
  stroke: currentColor;
  stroke-width: 20px;
  transition-property: stroke-dashoffset;
}

.icon--light {
  font-size: 2rem;
  color: $text-light-color;
}

.icon--dark {
  font-size: 2rem;
  color: $dark-color;
  fill: $dark-color;
}

/* === HEADINGS === */
.heading {
  font-family: $theme-font-family;
}

.heading--main {
  font-size: 2rem;
}

.heading--sec {
  font-size: 1.5rem;
}

.heading--branded {
  color: $primary-color;
}

/* created via js */
.showcase-gallery__el,
.showcase-gallery__el > img {
  width: 100%;
  display: block;
}

/* === FORM === */

/* === OVERRIDE FLICKITY BUTTONS */

/* === STICKY SHOWCASE TEXT / FIXED STICKY PLUGIN === */
.fixedsticky {
  position: sticky;
  top: 0;
}

/* When position: sticky is supported but native behavior is ignored */
.fixedsticky-withoutfixedfixed .fixedsticky-off,
.fixed-supported .fixedsticky-off {
  position: static;
}

.fixedsticky-withoutfixedfixed .fixedsticky-on,
.fixed-supported .fixedsticky-on {
  position: fixed;
}

.fixedsticky-dummy {
  display: none;
}

.fixedsticky-on + .fixedsticky-dummy {
  display: block;
}

/* === LAYER === */

/* === HELPER CLASSES === */
.hidden {
  display: none !important;
  visibility: hidden;
}

.cf:after {
  content: " ";
  clear: both;
  display: table;
}

.ph {
  padding-right: 2em;
  padding-left: 2em;
}

@include media-breakpoint-up(sm) {
  .btn ~ .btn {
    margin-left: 2em;
  }
}

@include media-breakpoint-down(xs) {
  .btn-wrapper {
    display: flex;
    flex-direction: column;
    align-items: center;
  }
}

@include media-breakpoint-down(md) {
  .btn {
    margin-bottom: 1em;
  }
}

</style>
